#! /bin/bash

. opts.sh

[ -z "$setup" ] && { echo "Setup must be specified (use 'all' to populate all known setups)"; exit 1; }

case $setup in
  autogen)
    oc -n $ADEI_NS new-app --template=adei -p setup=autogen -p enable_logs=0 -p adei_replicas=1 -p cache_replicas=1 -p sched_parallel=sources -p cache_parallel=sources -p continuous_caching=1
    ;;
  katrin)
    oc -n $ADEI_NS new-app --template=adei -p setup=katrin -p enable_logs=1 -p adei_replicas=1 -p cache_replicas=3 -p sched_parallel=sources -p cache_parallel=groups -p haproxy_timeout=300s
    ;;
  all)
    bash provision.sh -s autogen "$@"
    bash provision.sh -s katrin "$@"
    ;;
  *)
    echo "setup is not configured yet"
esac
